import Vue from 'vue'
import router from './router'
import store from './store'
import NProgress from 'nprogress' // progress bar
import 'nprogress/nprogress.css' // progress bar style
import notification from 'ant-design-vue/es/notification'
import { ACCESS_TOKEN } from '@/store/mutation-types'
import { generateIndexRouter } from "@/utils/util"
import warterMark from './warterMark'
import { mapGetters, mapMutations, mapActions } from 'vuex'
import { cmpPos } from 'codemirror'
NProgress.configure({ showSpinner: false }) // NProgress Configuration


const whiteList = ['/user/login', '/user/register', '/user/register-result', '/user/alteration', '/user/transfer-local', '/errorPage', '/user/new-batch', '/user/lookPreview', 'http://192.168.0.111:8088/jeecg-boot/sys/feishu/url', '/user/FStransfer', '/creat-config', '/create-launch', '/boss-data-kanban'] // no redirect whitelist

router.beforeEach((to, from, next) => {
  NProgress.start() // start progress bar
  //if (whiteList.indexOf(to.path) !== -1) {
  // 在免登录白名单，直接进入
  // next()
  //}
  console.log(to,from)
  if (Vue.ls.get(ACCESS_TOKEN)) {
    console.log(store.getters.userInfo.id);
    /* has token */
   
    if (to.path === '/user/login') {
      warterMark.out();
     
      next({ path: '/dashboard/workplace' })
     
      NProgress.done()
    } else {

      // warterMark.set(store.getters.userInfo.roleName)

      if (store.getters.permissionList.length === 0) {
       
        store.dispatch('GetPermissionList').then(res => {
          const menuData = res.result.menu;
          localStorage.setItem("roleCode", res.result.roleCode)
          if (menuData === null || menuData === "" || menuData === undefined) {
            return;
          }
          let constRoutes = [];
          constRoutes = generateIndexRouter(menuData);
          // 添加主界面路由
          store.dispatch('UpdateAppRouter', { constRoutes }).then(() => {
            // 根据roles权限生成可访问的路由表
            // 动态添加可访问路由表
            router.addRoutes(store.getters.addRouters)
            const redirect = decodeURIComponent(from.query.redirect || to.path)
            if (to.path === redirect) {
              // hack方法 确保addRoutes已完成 ,set the replace: true so the navigation will not leave a history record
              next({ ...to, replace: true })
            } else {
              // 跳转到目的路由
              // if( to.path === '/dashboard/analysis' && from.path == '/'){
              //   if (store.getters.userInfo.id == '4aba62011120ac565c7f2b9f8f4aa96b' || store.getters.userInfo.id == 'e9ca23d68d884d4ebb19d07889727dae') {
              //     const a = document.createElement('a');
              //                         document.body.appendChild(a);
              //                         a.style.display = 'none';
              //                         a.href = 'http://192.168.0.195:9001/boss-data-kanban';
              //                         a.target = '_blank'
              //                         a.click();
              //                         document.body.removeChild(a);
              //     // let tempPage = window.open('', '_blank');
              //     // tempPage.location="/boss-data-kanban";
              //   }
              // }
              next({ path: redirect })
            }
          })
        })
          .catch(() => {
            /* notification.error({
               message: '系统提示',
               description: '请求用户信息失败，请重试！'
             })*/
            warterMark.out()
            store.dispatch('Logout').then(() => {
              next({ path: '/user/login', query: { redirect: to.fullPath } })
            })
          })
      } else {
        warterMark.set(store.getters.userInfo.realname)
        next()
      }
      // if( to.path === '/dashboard/analysis' && from.path == '/'){
      //   if (store.getters.userInfo.id == '4aba62011120ac565c7f2b9f8f4aa96b' || store.getters.userInfo.id == 'e9ca23d68d884d4ebb19d07889727dae') {
      //     const a = document.createElement('a');
      //                         document.body.appendChild(a);
      //                         a.style.display = 'none';
      //                         a.href = 'http://192.168.0.195:9001/boss-data-kanban';
      //                         a.target = '_blank'
      //                         a.click();
      //                         document.body.removeChild(a);
      //     // let tempPage = window.open('', '_blank');
      //     // tempPage.location="/boss-data-kanban";
      //     return
      //   }
      // }
    }
  } else {
    if (whiteList.indexOf(to.path) !== -1) {
      // 在免登录白名单，直接进入
      // warterMark.set(store.getters.userInfo.roleName)
      next()
    } else {
      warterMark.out()
      next({ path: '/user/login', query: { redirect: to.fullPath } })
      NProgress.done() // if current page is login will not trigger afterEach hook, so manually handle it
    }
  }
})

router.afterEach(() => {
  NProgress.done() // finish progress bar
})
